import prog.io.ConsoleInputManager;
import prog.io.ConsoleOutputManager;
import prog.utili.Figura;
import prog.utili.Rettangolo;
import prog.utili.Quadrato;


class FiguraAreaMax{

  public static void main(String[] args) {
      //predisposizione dei canali di comunicazione
      ConsoleOutputManager out = new ConsoleOutputManager();
      ConsoleInputManager in = new ConsoleInputManager();

      Rettangolo r, rAreaMax = null;
      boolean continuare;
      double x, y;
      do{
	  //lettura dati figura
	  out.println("Inserisci i dati della figura:");
	  x = in.readDouble(" - base?  ");
	  y = in.readDouble(" - altezza? ");

	  //controllo dati e costruzione dell'oggetto
	  if (x < 0 || y < 0)
	      out.println("I dati inseriti non sono corretti");
	  else {
	      if (x == y){
	      r = new Quadrato(x);
	      out.println("La figura e' un quadrato: ");
	      }
	      else{
		  r = new Rettangolo(x, y);
	      out.println("La figura e' un rettangolo: ");
	      }
	      out.println("  " + r.toString());
	      out.println(" area =  " + r.getArea() + 
			  ", perimetro = " + r.getPerimetro());

	      //confronto
	      if (rAreaMax == null || r.haAreaMaggiore(rAreaMax))
		  rAreaMax = r;
	  }
	  out.println();

	  continuare = in.readSiNo("Vuoi inserire nuovi dati? (si/no) ");
      }
      while (continuare);

      //comunicazione risultato
      if (rAreaMax == null)
	  out.println("Non e' stato inserito alcun rettangolo");
      else{
	  out.println("La figura di area maggiore e' un ");
	  if (rAreaMax instanceof Quadrato)
	      out.println("quadrato: ");
	  else
	      out.println("rettangolo: ");
	  out.println("  " + rAreaMax.toString());
	  out.println("  area = " + rAreaMax.getArea() +
		      ", perimetro = " + rAreaMax.getPerimetro());
      }
  }
}
